﻿//------------------------------------------------------------------------------
//  Copyright(C) 2022  Gerald Fahrnholz
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program. If not, see <http://www.gnu.org/licenses/>.
//
//    Contact: http://www.gerald-fahrnholz.eu/impressum.php
//------------------------------------------------------------------------------

namespace TestExecWin_VS2022
{
    public interface IMainEvents
    {
        void OnGuiIsStarted();
        void OnSettingsHaveChanged();
        void OnRefreshAll();
        void OnRefreshNow();
        void OnSetOutputLevel(int in_level);
        void OnStartBuilding();
        void OnBuildTerminated(bool success);
        void OnStartTest(string exePath, string args, string workDir);
        void OnTestTerminated(bool in_success, string in_args, bool in_memLeaksDetected, TimeSpan in_executionTime);
        void OnStopAll();
        void OnStartDebugging(string in_cmdLineParams);
        void OnOpenProtocolFile();
        void OnOpenSourceFile(string in_fullFileName, int in_lineNum);
        string OnGetExecutablesFromCurrentSolution();
    }

    public interface IEventReceiver
    {
        void WriteLine(int in_outputLevel, String in_info);
        void MsgBox(String in_info);
    }

    public interface IExecute
    {
        void SetMemLeakCheck(bool in_state);
        void StartProcess(string exePath, string args, string workDir);
        void KillRunningProcess();
    }

}